S3AEncryptionMethods (Apache Hadoop Main 3.5.0 API)
Description: declaration: package: org.apache.hadoop.fs.s3a, enum: S3AEncryptionMethods

Package org.apache.hadoop.fs.s3a

# Enum Class S3AEncryptionMethods

java.lang.Object
java.lang.Enum<S3AEncryptionMethods>
org.apache.hadoop.fs.s3a.S3AEncryptionMethods

All Implemented Interfaces:
  `Serializable`, `Comparable<S3AEncryptionMethods>`, `Constable`

public enum S3AEncryptionMethods extends Enum<S3AEncryptionMethods>
This enum is to centralize the encryption methods and the value required in the configuration.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CSE_CUSTOM`
  `CSE_KMS`
  `DSSE_KMS`
  `NONE`
  `SSE_C`
  `SSE_KMS`
  `SSE_S3`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `UNKNOWN_ALGORITHM`
  Error string when `getMethod(String)` fails.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getMethod()`
  `static S3AEncryptionMethods`
  `getMethod(String name)`
  Get the encryption mechanism from the value provided.
  `boolean`
  `isServerSide()`
  Flag to indicate this is a server-side encryption option.
  `boolean`
  `requiresSecret()`
  Does this encryption algorithm require a secret?
  `static S3AEncryptionMethods`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static S3AEncryptionMethods[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### NONE

    public static final S3AEncryptionMethods NONE

  - ### SSE_S3

    public static final S3AEncryptionMethods SSE_S3

  - ### SSE_KMS

    public static final S3AEncryptionMethods SSE_KMS

  - ### SSE_C

    public static final S3AEncryptionMethods SSE_C

  - ### CSE_KMS

    public static final S3AEncryptionMethods CSE_KMS

  - ### CSE_CUSTOM

    public static final S3AEncryptionMethods CSE_CUSTOM

  - ### DSSE_KMS

    public static final S3AEncryptionMethods DSSE_KMS

- ## Field Details

  - ### UNKNOWN_ALGORITHM

    public static final String UNKNOWN_ALGORITHM
    Error string when `getMethod(String)` fails. Used in tests.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### values

    public static S3AEncryptionMethods[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static S3AEncryptionMethods valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getMethod

    public String getMethod()

  - ### isServerSide

    public boolean isServerSide()
    Flag to indicate this is a server-side encryption option.
    Returns:
      true if this is server side.

  - ### requiresSecret

    public boolean requiresSecret()
    Does this encryption algorithm require a secret?
    Returns:
      true if a secret must be retrieved.

  - ### getMethod

    public static S3AEncryptionMethods getMethod(String name) throws IOException
    Get the encryption mechanism from the value provided.
    Parameters:
      `name` - algorithm name
    Returns:
      the method
    Throws:
      `IOException` - if the algorithm is unknown